package me.wazup.hideandseek;

import org.bukkit.event.Event;
import me.wazup.hideandseek.events.HASPlayerJoinEvent;
import org.bukkit.GameMode;
import org.bukkit.potion.PotionEffect;
import org.bukkit.plugin.Plugin;
import org.bukkit.scheduler.BukkitRunnable;
import java.util.List;
import org.bukkit.inventory.ItemStack;
import me.wazup.hideandseek.utils.Utils;
import org.bukkit.entity.Player;
import java.util.Iterator;
import org.bukkit.Bukkit;
import org.bukkit.configuration.file.FileConfiguration;
import me.wazup.hideandseek.utils.FlexibleScoreboard;
import java.util.HashMap;
import org.bukkit.scheduler.BukkitTask;

public class BungeeMode
{
    public Arena selectedArena;
    public int lock_votes_at;
    public int Seconds;
    HideAndSeek plugin;
    int minPlayers;
    int maxPlayers;
    int lobby_time;
    int skip_time_at;
    int skip_time_to;
    public String hub;
    boolean voting_enabled;
    int Games;
    BukkitTask mainTimer;
    public HashMap<String, Integer> arenasVotes;
    public FlexibleScoreboard scoreboard;
    
    public BungeeMode(final HideAndSeek plugin, final FileConfiguration fileConfiguration) {
        this.Games = 0;
        this.arenasVotes = new HashMap<String, Integer>();
        this.minPlayers = fileConfiguration.getInt("BungeeMode.min_players");
        this.maxPlayers = Bukkit.getMaxPlayers();
        this.lobby_time = fileConfiguration.getInt("BungeeMode.lobby_time");
        this.skip_time_at = fileConfiguration.getInt("BungeeMode.skip_time_at");
        this.skip_time_to = fileConfiguration.getInt("BungeeMode.skip_time_to");
        this.lock_votes_at = fileConfiguration.getInt("BungeeMode.lock_votes_at");
        this.Seconds = this.lobby_time;
        this.voting_enabled = fileConfiguration.getBoolean("BungeeMode.voting_enabled");
        this.hub = fileConfiguration.getString("BungeeMode.hub-name");
        this.plugin = plugin;
    }
    
    public void createScoreboard() {
        this.scoreboard = new FlexibleScoreboard(Arena.ArenaState.WAITING.text + " 0:00", this.voting_enabled, Customization.getInstance().bungeeModeScoreboard);
        if (this.voting_enabled) {
            final Iterator<Arena> iterator = Arena.arenaObjects.iterator();
            while (iterator.hasNext()) {
                this.scoreboard.setNonTrackableScore(iterator.next().name, 0);
            }
        }
        this.scoreboard.update("%players%", 0);
        this.scoreboard.update("%game%", this.Games + 1);
    }
    
    public void join(final Player player, final boolean b) {
        final String name = player.getName();
        this.plugin.playerData.get(player.getName()).arena = Arena.arenaObjects.get(0);
        this.plugin.game.add(name);
        this.plugin.grace.add(name);
        Utils.playSound(player, "Player-Join-Arena");
        this.plugin.clearPlayerData(player);
        if (Config.getInstance().arenaHotbarItems.containsKey("Shop")) {
            player.getInventory().setItem((int)Config.getInstance().arenaHotbarItems.get("Shop"), (ItemStack)Customization.getInstance().items.get("Shop"));
        }
        if (Config.getInstance().arenaHotbarItems.containsKey("Quit")) {
            player.getInventory().setItem((int)Config.getInstance().arenaHotbarItems.get("Quit"), (ItemStack)Customization.getInstance().items.get("Quit"));
        }
        if (Config.getInstance().arenaHotbarItems.containsKey("Lobby-Book")) {
            player.getInventory().setItem((int)Config.getInstance().arenaHotbarItems.get("Lobby-Book"), this.plugin.book);
        }
        if (Config.getInstance().trailsEnabled && player.hasPermission("hideandseek.trails") && Config.getInstance().arenaHotbarItems.containsKey("Trails")) {
            player.getInventory().setItem((int)Config.getInstance().arenaHotbarItems.get("Trails"), (ItemStack)Customization.getInstance().items.get("Trails"));
        }
        if (Config.getInstance().arenaHotbarItems.containsKey("Vote")) {
            player.getInventory().setItem((int)Config.getInstance().arenaHotbarItems.get("Vote"), (ItemStack)Customization.getInstance().items.get("Vote"));
        }
        if (Config.getInstance().arenaHotbarItems.containsKey("Achievements")) {
            player.getInventory().setItem((int)Config.getInstance().arenaHotbarItems.get("Achievements"), (ItemStack)Customization.getInstance().items.get("Achievements"));
        }
        this.scoreboard.apply(player);
        if (this.plugin.globalLobby != null) {
            player.teleport(this.plugin.globalLobby);
        }
        final List onlinePlayers = Utils.getOnlinePlayers();
        final int i = onlinePlayers.contains(player) ? onlinePlayers.size() : (onlinePlayers.size() + 1);
        final boolean b2 = i >= this.minPlayers && this.mainTimer == null;
        if (!b) {
            Bukkit.broadcastMessage(this.plugin.customization.messages.get("arena_join_broadcast").replace("%player%", player.getName()).replace("%players%", String.valueOf(i)).replace("%maxPlayers%", String.valueOf(this.maxPlayers)) + "\n" + (b2 ? this.plugin.customization.messages.get("arena_about_to_start") : ((i < this.minPlayers) ? this.plugin.customization.messages.get("arena_needs_players").replace("%players%", String.valueOf(this.minPlayers - i)) : "")));
        }
        if (this.mainTimer != null && this.Seconds > this.skip_time_to && i >= this.skip_time_at) {
            this.Seconds = this.skip_time_to;
            Bukkit.broadcastMessage(this.plugin.customization.messages.get("time_skip").replace("%seconds%", String.valueOf(this.Seconds)));
        }
        if (!b) {
            this.scoreboard.update("%players%", i);
        }
        if (b2) {
            this.startMainTimer();
        }
    }
    
    public void leave(final Player player) {
        this.plugin.game.remove(player.getName());
        this.plugin.grace.remove(player.getName());
        if (this.selectedArena == null || this.selectedArena.state.equals(Arena.ArenaState.WAITING)) {
            final int i = Utils.getOnlinePlayers().size() - 1;
            Bukkit.broadcastMessage(this.plugin.customization.messages.get("arena_leave_broadcast").replace("%player%", player.getName()).replace("%players%", String.valueOf(i)).replace("%maxPlayers%", String.valueOf(this.maxPlayers)));
            this.scoreboard.update("%players%", i);
            this.removePlayerVotes(player);
            if (this.mainTimer != null && i < this.minPlayers) {
                this.mainTimer.cancel();
                this.mainTimer = null;
                this.scoreboard.setName(Arena.ArenaState.WAITING.text + " 0:00");
                this.Seconds = this.lobby_time;
                final String s = this.plugin.customization.messages.get("arena_cancel");
                for (final Player player2 : Utils.getOnlinePlayers()) {
                    player2.sendMessage(s);
                    player2.setLevel(0);
                }
                if (this.selectedArena != null) {
                    for (final Player player3 : Utils.getOnlinePlayers()) {
                        player3.getInventory().removeItem(new ItemStack[] { Perk.DisguiseSelector.purchased });
                        if (this.voting_enabled && Config.getInstance().arenaHotbarItems.containsKey("Vote")) {
                            player3.getInventory().setItem((int)Config.getInstance().arenaHotbarItems.get("Vote"), (ItemStack)Customization.getInstance().items.get("Vote"));
                        }
                    }
                    this.selectedArena = null;
                }
            }
        }
        else {
            this.selectedArena.leave(player);
        }
    }
    
    private void startMainTimer() {
        this.mainTimer = new BukkitRunnable() {
            public void run() {
                if (Config.getInstance().ArenaStartWarnAt.contains(BungeeMode.this.Seconds)) {
                    final String replace = BungeeMode.this.plugin.customization.messages.get("arena_starting").replace("%seconds%", String.valueOf(BungeeMode.this.Seconds));
                    for (final Player player : Utils.getOnlinePlayers()) {
                        player.sendMessage(replace);
                        Utils.playSound(player, "Arena-Starting");
                    }
                }
                if (BungeeMode.this.Seconds == BungeeMode.this.lock_votes_at) {
                    BungeeMode.this.selectArena();
                }
                final Iterator iterator2 = Utils.getOnlinePlayers().iterator();
                while (iterator2.hasNext()) {
                    ((Player)iterator2.next()).setLevel(BungeeMode.this.Seconds);
                }
                BungeeMode.this.scoreboard.setName(Arena.ArenaState.STARTING.text + " " + Arena.getDurationString(BungeeMode.this.Seconds));
                if (BungeeMode.this.Seconds == 0) {
                    this.cancel();
                    BungeeMode.this.mainTimer = null;
                    BungeeMode.this.start();
                }
                final BungeeMode this$0 = BungeeMode.this;
                --this$0.Seconds;
            }
        }.runTaskTimer((Plugin)this.plugin, 0L, 20L);
    }
    
    public void start() {
        if (this.selectedArena == null) {
            this.selectArena();
        }
        final Iterator<String> iterator = this.arenasVotes.keySet().iterator();
        while (iterator.hasNext()) {
            this.arenasVotes.put(iterator.next(), 0);
        }
        final Iterator<PlayerData> iterator2 = this.plugin.playerData.values().iterator();
        while (iterator2.hasNext()) {
            iterator2.next().votes.clear();
        }
        this.Seconds = this.lobby_time;
        for (final Player player : Utils.getOnlinePlayers()) {
            this.plugin.playerData.get(player.getName()).played = true;
            final Iterator iterator4 = player.getActivePotionEffects().iterator();
            while (iterator4.hasNext()) {
                player.removePotionEffect(((PotionEffect)iterator4.next()).getType());
            }
            player.getInventory().clear();
            player.setGameMode(GameMode.SURVIVAL);
            player.setFireTicks(0);
            player.setFlying(false);
            player.setAllowFlight(false);
            this.selectedArena.players.add(player.getName());
            if (this.selectedArena.scoreboard != null) {
                this.selectedArena.scoreboard.apply(player);
            }
            else {
                player.setScoreboard(Bukkit.getScoreboardManager().getMainScoreboard());
            }
            Bukkit.getPluginManager().callEvent((Event)new HASPlayerJoinEvent(player, this.selectedArena));
        }
        this.selectedArena.startGame();
    }
    
    public void selectArena() {
        if (this.voting_enabled) {
            int intValue = -1;
            for (final String s : this.arenasVotes.keySet()) {
                if (this.arenasVotes.get(s) > intValue) {
                    intValue = this.arenasVotes.get(s);
                    this.selectedArena = Arena.valueOf(s);
                }
            }
            Bukkit.broadcastMessage(this.plugin.customization.messages.get("map_select").replace("%map%", this.selectedArena.name));
        }
        else {
            this.selectedArena = Arena.arenaObjects.get(Utils.random.nextInt(Arena.arenaObjects.size()));
        }
        for (final Player player : Utils.getOnlinePlayers()) {
            this.plugin.playerData.get(player.getName()).arena = this.selectedArena;
            if (this.plugin.playerData.get(player.getName()).hasPerk(Perk.DisguiseSelector)) {
                player.getInventory().addItem(new ItemStack[] { Perk.DisguiseSelector.purchased });
            }
            player.getInventory().remove((ItemStack)Customization.getInstance().items.get("Vote"));
        }
    }
    
    public void removePlayerVotes(final Player player) {
        for (final String key : this.plugin.playerData.get(player.getName()).votes) {
            this.arenasVotes.put(key, this.arenasVotes.get(key) - 1);
            this.scoreboard.setNonTrackableScore(key, (int)this.arenasVotes.get(key));
        }
        this.plugin.playerData.get(player.getName()).votes.clear();
    }
}
